#include <unistd.h>  // declares read()
#include <stdlib.h>  // declares exit()
#include <stdio.h>   // declares fprintf()
#include <string.h>  // declares strerror()
#include <errno.h>   // declares errno


/**************************
 * Error-handling function
 **************************/
void unix_error(char *msg) /* unix-style error */
{
   fprintf(stderr, "%s: %s (errno = %d)\n", msg, strerror(errno), errno);
   exit(0);
}


/**********************************
 * Wrappers for Unix I/O routines
 **********************************/
ssize_t Read(int fd, void *buf, size_t count)
{
   ssize_t rc;

   if ((rc = read(fd, buf, count)) < 0)
      unix_error("Read error");
   return rc;
}


/**********************************
 * main()
 **********************************/
int main()
{
   char c;
   int counter = 0;

   while(Read(STDIN_FILENO, &c, 1) != 0)
      counter++;

   printf("%d characters read from standard input", counter);

   exit(0);
}
